import graphEntity from './graphEntityClient';

const { field, query, mutate, exclude } = graphEntity;

class CodedValue {
  @field('String') code;
  @field('String') description;
}
class Team {
  @field('ID') id;
  @field('Date') createdAt;
  @field('Date') updatedAt;
  @field('String') name;
  @field('String') description;
  @field('Enum') healthCondition;
  @field({
    role: 'Enum',
    primary: 'Boolean'
  })                        members;
}

class User {
  @field('String')          id;
  @field('Date')            createdAt;
  @field('Date')            updatedAt;
  @field('String')          username;
  @field('Enum')            role;
  @field({
    address: 'String',
    primary: 'Boolean',
    verified: 'Boolean'
  })                        emails;
  @field({
    type: 'Enum',
    countryCode: 'String',
    areaCode: 'String',
    number: 'String',
    primary: 'Boolean',
    verified: 'Boolean'
  })                        phones;
  @field({
    type: 'CodedValue',
    value: 'String',
    MRN: 'Boolean'
  })                        identifications;
  @field({
    type: 'Enum',
    streetName: 'String',
    streetNumber: 'String',
    floor: 'String',
    unit: 'String',
    city: 'String',
    state: 'String',
    country: 'CodedValue',
    postCode: 'String'
  })                        addresses;
  @field({
    title: 'Enum',
    firstName: 'String',
    lastName: 'String',
    fullName: 'String',
    avatar: 'String',
    gender: 'String'
  })                         profile;
  @field({
    building: 'String',
    floor: 'String',
    room: 'String',
    admissionDate: 'Date'
  })                        residency;
  @field('Team')            team;
  // @field('String') organization: [Organization]
  // @field('String') memberIn: [Organization]
  // @field('String') userSettings: UserSettings
  // @field('String') starred: Boolean
  // @field('String') starredReason: String@field('String')
}

